///home/berryj/link/bin/genMethods "-t" "Attribute<Vertex*>*" "-I" "LINK/graph/Attribute.h" "-I" "LINK/graph/Vertex.h" "-d" "graph" "-y" "display_attribute_vertexptr" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Attribute.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_attribute_vertexptr(SCM, SCM, int);

typedef Attribute<Vertex*>* _Attribute_Vertex___;

#define _Attribute_Vertex___DATA(x) ((Attribute<Vertex*>**) (EXTDATA(x)))
#define _Attribute_Vertex___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<Vertex*>* >::type))
#define _Attribute_Vertex___ISNT_DATA(x) (!_Attribute_Vertex___IS_DATA(x))

#define _Attribute_Vertex___CXX_DATA(x) (*(Attribute<Vertex*>**) (EXTDATA(VAL(x))))
#define _Attribute_Vertex___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<Vertex*>* >::type))
#define _Attribute_Vertex___CXX_ISNT_DATA(x) (!_Attribute_Vertex___CXX_IS_DATA(x))


static SCM is_Attribute_Vertex___(SCM i)
{
	if (_Attribute_Vertex___CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init__Attribute_Vertex___()
{
	Wrapper<_Attribute_Vertex___>::type = STk_new_CXXwrapper_id(
			Wrapper<_Attribute_Vertex___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_attribute_vertexptr,
			(void (*)(SCM x))0,
			(void (*)(SCM x))0);
	Tcl_InitHashTable(&Register<_Attribute_Vertex___>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("Attribute-Vertex?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_Attribute_Vertex___);
	return UNDEFINED;
}

void genExtra_Attribute_Vertex___Methods(void);

PRIMITIVE STk_init_methods__Attribute_Vertex___()
{
	genExtra_Attribute_Vertex___Methods();
	return UNDEFINED;
}
